/*
 * Created on 28-feb-2005
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package kano.inter;

import java.io.InputStream;
import java.util.Collection;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Properties;

import kano.exception.LogicApplicationException;

/**
 * @author dcano
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Messages
{
	private static Messages s_instance = new Messages();
	private HashMap m_hmMessages = null;
	
	private String m_strDefault = "en";
	private boolean m_bDefault = false;
	
	private Messages()
	{
		load();
	}
	
	public static Messages getInstance()
	{
		return s_instance;
	}
	
	public String getMessage(String strLanguage, String strKey)
	{
		return getMessage(strLanguage, strKey, null);
	}

	public String getMessage(String strLanguage, String strKey, String[] params)
	{
		String strMessage = strKey;
		if (strLanguage == null)
			strLanguage = m_strDefault;
		HashMap hmLang = (HashMap)m_hmMessages.get(strLanguage);
		if (hmLang == null)
		{
			strLanguage = m_strDefault;
			hmLang = (HashMap)m_hmMessages.get(strLanguage);
		}
		if (hmLang != null)
		{
			String strAux = (String)hmLang.get(strKey);
			if (strAux != null)
				strMessage = strAux;
		}
		
		if (params != null)
			strMessage = format(strMessage, params);
		
		return strMessage;
	}

	public synchronized void load()
	{
		try
		{
			///*#DEBUG#*/System.out.println("!!!!!!!!!!RELOAD!!!!!!!!!!!");
			m_hmMessages = new HashMap();
			InputStream is = getClass().getResourceAsStream("/kano/inter/messages.properties");
			Properties p = new Properties();
			p.load(is);
			
			Enumeration e = p.keys();
			while (e.hasMoreElements())
			{
				String strKey = null;
				try
				{
					strKey = (String)e.nextElement();
					String strValue = (String)p.getProperty(strKey);
					HashMap hm = load(strValue);
					m_hmMessages.put(strKey, hm);
					if (!m_bDefault)
					{
						m_bDefault = true;
						m_strDefault = strKey;
					}
				}
				catch(Exception e2)
				{
					///*#DEBUG#*/System.out.println("Error loading messages " + strKey);
					e2.printStackTrace();
				}
			}
		}
		catch(Exception e)
		{
			///*#DEBUG#*/System.out.println("Error loading messages");
			e.printStackTrace();
		}
	}
	
	private HashMap load(String strFile) throws Exception
	{
		InputStream is = getClass().getResourceAsStream("/kano/inter/" + strFile);
		Properties p = new Properties();
		p.load(is);
		HashMap hm = new HashMap(p.size());
			
		Enumeration e = p.keys();
		while (e.hasMoreElements())
		{
			String strKey = (String)e.nextElement();
			String strValue = (String)p.getProperty(strKey);
			hm.put(strKey, strValue);
		}
		
		return hm;
	}
	
	public String getDefaultLanguage()
	{
		return m_strDefault;
	}
	
	public Collection getLanguages()
	{
		return m_hmMessages.keySet();
	}
	
	public String format(String strMessage, String[] params)
	{
		return String.format(strMessage, params);
	}
	
	public String formatError(String strLang, LogicApplicationException le)
	{
		return getMessage(strLang, le.getMessage(), le.getParams());
	}
}
